var action = 'Save';
var shipment_id = null;

$(document).ready(function () {
    $('#txtShipmentNo').val(newID());
    var tableAttachment = $('#myTable').DataTable({
        responsive: false,
        "scrollX": true,
        scrollY: 300,
        scrollX: true,
        "pageLength": 100,
        "order": [],
        "columns": [
            { "data": "shipment_no" },
            { "data": "shipment_type" },
            { "data": "loading_date" },
            { "data": "customer_order_id" },
            { "data": "factory_order_no" },
            { "data": "freight_by" },
            { "data": "no_of_container" },
            { "data": "container_type" },
            { "data": "action" },
            { "data": "view", className: "edit", orderable: false },
            { "data": "edit", className: "edit", orderable: false },
            { "data": "delete", className: "edit", orderable: false },
        ],
        columnDefs: [
            { width: 80, targets: 1 },
            { width: 80, targets: 2 },
            { width: 80, targets: 3 },
        ],
    });

    $("#btnShipmentSave").on("click", function (e) {

        if ($(this).text() == "Save") {
            saveSchedule();
            e.preventDefault();
        } else {
            updateSchedule(shipment_id);
        }
    });

    allShipment();
    getCustomerOrderNo();


    checkInput("#customer_order_id");
    checkInput("#no_of_container");
    checkInput("#container_type");
    checkInput("#loading_date");
    checkInput("#shipment_type");
    checkInput("#freight_by");

});

$('#btnAttachment').on('click', function () {

    $('#attachmentAddModal').modal('show');
});

function resetScheduleForm() {
    $('#formShipment').trigger("reset");
}

function saveSchedule() {

    var exterl_id = newID();
    var shipment_type = $('#shipment_type').val();

    if (shipment_type == 1) {
        if ($('#customer_order_id').attr('data-id') == '' || $('#no_of_container').val() == '' || $('#container_type').val() == '') {
            showWarningMessage("Please make sure Customer No|No of Container or Container type are filled in correctly.");
            return false;
        }
    }

    $.ajax({
        type: "POST",
        url: '/sd/shipment/saveSchedule',
        data: {
            "shipment_no": exterl_id,
            "shipment_type": $('#shipment_type').val(),
            "loading_date": $('#loading_date').val(),
            "customer_order_id": $('#customer_order_id').attr('data-id'),
            "freight_by": $('#freight_by').val(),
            "no_of_container": $('#no_of_container').val(),
            "container_type": $('#container_type').val(),
            "status": $('#status').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            // window.location.reload();
            if (response.data.success) {


                $("#attachmentAddModal").trigger("reset");

                $("#shipment_type").attr("class", "form-control");
                $("#loading_date").attr("class", "form-control");
                $("#customer_order_id").attr("class", "form-control");
                $("#freight_by").attr("class", "form-control");
                $("#no_of_container").attr("class", "form-control");
                $("#container_type").attr("class", "form-control");

                $("#txtShipmentNo").val(exterl_id);
                $("#shipment_type").val("");
                $("#loading_date").val("");
                $("#customer_order_id").val("");
                $("#freight_by").val("");
                $("#no_of_container").val("");
                $("#container_type").val("");
                $("#status").val("");

                resetScheduleForm();
                allShipment();

                toastr.success('Shipment data has been saved successful...!');
            } else {
                showWarningMessage("Please make sure all fields are filled in correctly.");
                if (response.data.result.errorInfo) {
                    showWarningMessage("Please make sure all fields are filled in correctly.");
                }
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {

        }

    });
}

function updateSchedule(shipment_id) {
    var exterl_id = newID();
    $.ajax({
        type: "post",
        url: "/sd/shipment/update/" + shipment_id,
        data: {
            shipment_no: $('#txtShipmentNo').val(),
            shipment_type: $('#shipment_type').val(),
            loading_date: $('#loading_date').val(),
            customer_order_id: $('#customer_order_id').val(),
            freight_by: $('#freight_by').val(),
            no_of_container: $('#no_of_container').val(),
            container_type: $('#container_type').val(),
            status: $('#status').val(),
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {
            $("#attachmentAddModal").trigger("reset");

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                allShipment();
                $("#attachmentAddModal").trigger("reset");
                $("#btnShipmentSave").text("Save");
                $("#txtShipmentNo").val(exterl_id).removeClass("is-valid is-invalid");
                $("#shipment_type").val("").removeClass("is-valid is-invalid");
                $("#loading_date").val("").removeClass("is-valid is-invalid");
                $("#customer_order_id").val("").removeClass("is-valid is-invalid");
                $("#freight_by").val("").removeClass("is-valid is-invalid");
                $("#no_of_container").val("").removeClass("is-valid is-invalid");
                $("#container_type").val("").removeClass("is-valid is-invalid");
                $("#status").val("").removeClass("is-valid is-invalid");
                $(".is-invalid").hide().removeClass("is-valid is-invalid");
                $(".is-valid").hide().removeClass("is-valid is-invalid");
                toastr.success("data updated").removeClass("is-valid is-invalid");
                $("#attachmentAddModal").trigger("reset");
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () { },
    });
}

function allShipment() {
    $.ajax({
        type: "GET",
        url: "/sd/shipment/allShipment",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                var data = [];
                var ShipmentType = '';
                var freightBy = '';
                var containerType = '';
                for (var i = 0; i < result.length; i++) {
                    var shipment_id = response.data.result[i]["shipment_id"];
                    var status = response.data.result[i]["status"];
                    var shipment_type = response.data.result[i]["shipment_type"];
                    var freight_by = response.data.result[i]["freight_by"];
                    var container_type = response.data.result[i]["container_type"];

                    // if (seen == 0) {
                    //     var seenIcon = '<span class="badge badge-danger"><i class="fa fa-times" aria-hidden="true"></i></span>'
                    // } else {
                    //     var seenIcon = '<span class="badge badge-success"><i class="fa fa-check" aria-hidden="true"></i></span>'
                    // }

                    // for shipment type
                    switch (shipment_type) {
                        case '':
                            ShipmentType = 'unspecified';
                            break;
                        case 1:
                            ShipmentType = 'Finished Goods';
                            break;
                        case 2:
                            ShipmentType = 'Sample';
                    }
                    // for freight_by
                    switch (freight_by) {
                        case '':
                            freightBy = 'unspecified';
                            break;
                        case 1:
                            freightBy = 'Sea Freight';
                            break;
                        case 2:
                            freightBy = ' Air Fraight';
                    }
                    // for shipment type
                    switch (container_type) {
                        case '':
                            containerType = 'unspecified';
                            break;
                        case 1:
                            containerType = '20FT General';
                            break;
                        case 2:
                            containerType = '40FT General';
                            break;
                        case 3:
                            containerType = '20FT High Cube';
                            break;
                        case 4:
                            containerType = '40FT High Cube';
                            break;
                    }


                    switch (status) {
                        case 0:
                            StatusIcon = '<span class="badge badge-primary">New</span>';
                            break;
                        case 1:
                            StatusIcon = '<span class="badge badge-success">Approved</span>';
                            break;
                        case 2:
                            StatusIcon = '<span class="badge badge-info">Revise</span>';
                            break;
                        case 3:
                            StatusIcon = '<span class="badge badge-danger">Reject</span>';
                    }

                    // action btn define
                    var vessel_action_button = '<div class="dropdown">';
                    vessel_action_button += '<button type="button" class="btn btn-primary dropdown-toggle" data-toggle="dropdown">';
                    vessel_action_button += ' Action';
                    vessel_action_button += '</button>';
                    vessel_action_button += '<div class="dropdown-menu">';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_scheduled(' + shipment_id + ')">Vessel Schedule</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="release_order(' + shipment_id + ')">Release order</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_availability(' + shipment_id + ')">Loarding Plan</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_availability(' + shipment_id + ',' + 3 + ')">Preshipment Document</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_availability(' + shipment_id + ',' + 4 + ')">Pallet</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_availability(' + shipment_id + ',' + 5 + ')">Inform USA office</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_availability(' + shipment_id + ',' + 6 + ')">Furmugations</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="bl_instruction(' + shipment_id + ')">B/L instruction</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_availability(' + shipment_id + ',' + 8 + ')">Collecting FInal Document</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_availability(' + shipment_id + ',' + 9 + ')">Clearance Documents USA </a>';
                    vessel_action_button += '</div></div>';


                    data.push({
                        "shipment_no": result[i].shipment_no,
                        "shipment_type": ShipmentType,
                        "loading_date": result[i].loading_date,
                        "customer_order_id": result[i].customer_order_id,
                        "factory_order_no": result[i].factory_order_no,
                        "freight_by": freightBy,
                        "no_of_container": result[i].no_of_container,
                        "container_type": containerType,
                        "action": vessel_action_button,
                        "view": '<button type= "button" class="btn btn-success" onclick="viewShipment(' + shipment_id + ');"><i class="fa fa-eye" aria-hidden="true"></i></button> ',
                        "edit": '<button type= "button" class="btn btn-primary" onclick="editShipment(' + shipment_id + ');"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button> ',
                        "delete": '<button type= "button" class="btn btn-danger" onclick="deleteShipment(' + shipment_id + ');"><i class="fa fa-trash" aria-hidden="true"></i></button> ',
                    });
                }
                var table = $('#myTable').DataTable();
                table.clear();
                table.rows.add(data).draw();
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}

function getShipmentData(id) {
    $.ajax({
        type: "GET",
        url: "/sd/shipment/getShipmentData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            if (response.data.success) {
                var res = response.data.result;
                $("#txtShipmentNo").val(res.shipment_no);
                $("#shipment_type").val(res.shipment_type);
                $("#loading_date").val(res.loading_date);
                $("#customer_order_id").val(res.customer_order_id);
                $("#freight_by").val(res.freight_by);
                $("#no_of_container").val(res.no_of_container);
                $("#container_type").val(res.container_type);
                $("#status").val(res.status);
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}

function getCustomerOrderNo() {
    $.ajax({
        type: "GET",
        url: "/sd/shipment/getOrderNo",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                var customer_id = response.data.result;
                $("#customer_order_id").setData(customer_id);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}

function viewShipment(id) {
    getShipmentData(id);
    $("#btnShipmentSave").hide();
    $('#attachmentAddModal').modal('toggle');
}

function editShipment(id) {
    shipment_id = id;
    getShipmentData(id);
    $("#btnShipmentSave").text("Update");
    $("#attachmentAddModal").modal("toggle");
}

function deleteShipment(id) {

    showAlert("Are You Sure?", id);
}

function showAlert(message, id) {
    swal({
        title: message,
        text: "Once deleted, you will not be able to recover this record!",
        icon: "warning",
        buttons: true,
        dangerMode: true,
    });

    $(".swal-button--confirm").on("click", function () {
        $.ajax({
            type: "DELETE",
            url: "/sd/shipment/delete/" + id,
            data: {
                shipment_id: id,
            },
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            },
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);
                if (response.data.success) {
                    allShipment();
                    showSuccessMessage("Attachment has been deleted successfully...");

                } else {
                    showErrorMessage();
                }

            },
            error: function (error) {
                console.log(error);

            },
            complete: function () {

            }
        });
    });
}

function vessel_scheduled(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/vsCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            if (res.length > 0) {
                window.location.href = 'vesselScheduleList/' + res[0].factory_po_num;
            } else {
                window.location.href = 'vesselSchedule/';
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}


function release_order(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/roCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'releaseOrderList/' + res[0].factory_po;
            } else {
                window.location.href = 'releaseOrder/';
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}

function bl_instruction(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/biCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'blInstructionList/' + res[0].factory_po;
            } else {
                window.location.href = 'blInstruction/';
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}

/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
